//ZDS Hex to TI-83+ Raw Hex converter

#include <fstream.h>
#include <string.h>
#include <stdlib.h>
#include <conio.h>

fstream in, out;

int main(int argc, char *argv[])
{
	char infile_name[501] = "\0", 
		outfile_name[501] = "\0",
		buffer[101] = "\0",
		write_buffer = '\0';

	system("CLS");
	cout<<"- ZDS Intel Hex to Raw Hex Converter (Beta) -\n"<<endl;

	if(argc==1)		//if no input file specified
	{
		cout<<"Proper usage:\n"<<endl;
		cout<<"\tzds_hex [filename(.hex)]"<<endl;
		getch();
		exit(0);
	}

	int length = strlen(argv[1]);
	strcpy(infile_name, argv[1]);
	in.open(infile_name, ios::in | ios::nocreate);
	if(!in)
	{
		cout<<"Error opening file!"<<endl;
		exit(0);
	}

	cout<<"Converting:\n"<<infile_name<<endl<<endl;

	for(int i=0; i<length-4; i++)	//minus 4 to remove .hex extension
		outfile_name[i] = infile_name[i];
	strcat(outfile_name, "_83p.hex");

	cout<<"Outputting raw hex to:\n"<<outfile_name<<endl<<endl;

	out.open(outfile_name, ios::out);	//ios::noreplase
	
	int char_count = 0;

	out<<"AsmPrgm\n";
	while(!in.eof())
	{		
		in.getline(buffer, 101, '\n');
		for(i=9; i<strlen(buffer); i++)
		{
			write_buffer = buffer[i];
			out<<write_buffer;
			char_count++;
			if(char_count >= 12)
			{
				out<<'\n';
				char_count = 0;
			}
		}
	}
	out.close();
	in.close();

	cout<<"Job done!"<<endl;
	getch();

	return (0);
}